package cz.muni.fi.lasaris.sbms.api.request;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import cz.muni.fi.lasaris.sbms.model.Fields;

public abstract class GroupableRequest {

	protected List<String> responseFields;
	private String grouping;
	private String[] g;

	public GroupableRequest() {
		responseFields = new ArrayList<String>();
	}

	public List<String> getResponseFields() {
		return responseFields;
	}

	public String getGrouping() {
		return grouping;
	}

	public String getGrouping(int i) {
		if(g == null || i < 0 || i > 2) {
			return Fields.DEFAULT_GROUPING;
		}
		return g[i];
	}

	public void setGrouping(String grouping) {
		this.grouping = grouping;
		if(grouping != null) {
			String[] gs = grouping.split("\\.");
			this.g =(gs.length > 1) ? new String[] {gs[0], Character.toUpperCase(gs[1].charAt(0)) + gs[1].substring(1)}
			: new String[] {gs[0], gs[0]};
		} else {
			this.g = new String[] { Fields.DEFAULT_GROUPING, Fields.DEFAULT_GROUPING };
		}
	}
	
	public void parseResponseFields(String fields) {
		if(fields != null) {
			for(String f : fields.split(",")) {
				if(StringUtils.isNotBlank(f)) {
					responseFields.add(f);
				}
			}
		}
	}
	
	public abstract String getIdentityField();

}